DASH Shell discussions
 help / color / mirror / Atom feed
From: Jonathan Nieder <jrnieder@gmail.com>
To: Herbert Xu <herbert@gondor.apana.org.au>
Cc: Eric Blake <eblake@redhat.com>, Gerrit Pape <pape@smarden.org>,
	dash@vger.kernel.org, "Krzysztof A. Sobiecki" <sobkas@gmail.com>,
	Jari Aalto <jari.aalto@cante.net>
Subject: Re: [PATCH 2/3] Revert "Eliminated global exerrno."
Date: Wed, 6 Oct 2010 22:35:18 -0500	[thread overview]
Message-ID: <20101007033518.GB2285@burratino> (raw)
In-Reply-To: <20101007025649.GA14649@gondor.apana.org.au>

Herbert Xu wrote:

> Actually the bug is elsewhere.

It does bisect to there. :)  But you're right, it would have been
simpler to send one patch.

> --- a/src/eval.c
> +++ b/src/eval.c
> @@ -854,7 +854,7 @@ bail:
>  			int i;
>  
>  			i = exception;
> -			if (i == EXEXIT)
> +			if (i == EXEXIT || i == EXEXEC)
>  				goto raise;

Good call.  This is better than my patch because it exits like it
ought to for

	command exec nonexistent

(as POSIX says:

	If command is specified, exec shall not return to the shell

).

Maybe the following would make sense on top?

-- 8< --
Subject: [EXCEPTIONS] Use EXEXIT in place of EXEXEC

The intended semantics of EXEXEC are identical to EXEXIT, so
simplify by using EXEXIT directly.

Functional change: in edge cases (exec within a trap handler),
this causes the exit status from exec not to be clobbered.
For example, without this patch:

 $ sh -c 'trap "exec nonexistent" EXIT'; echo $?
 exec: 1: nonexistent: not found
 0

And with it:

 $ sh -c 'trap "exec nonexistent" EXIT'; echo $?
 exec: 1: nonexistent: not found
 127

Signed-off-by: Jonathan Nieder <jrnieder@gmail.com>
---
 src/error.h |    1 -
 src/eval.c  |    2 +-
 src/exec.c  |    2 +-
 3 files changed, 2 insertions(+), 3 deletions(-)

diff --git a/src/error.h b/src/error.h
index be0eec9..f236d9f 100644
--- a/src/error.h
+++ b/src/error.h
@@ -66,7 +66,6 @@ extern int exception;
 /* exceptions */
 #define EXINT 0		/* SIGINT received */
 #define EXERROR 1	/* a generic error */
-#define EXEXEC 3	/* command execution failed */
 #define EXEXIT 4	/* exit the shell */
 
 
diff --git a/src/eval.c b/src/eval.c
index b966749..5b8d36b 100644
--- a/src/eval.c
+++ b/src/eval.c
@@ -854,7 +854,7 @@ bail:
 			int i;
 
 			i = exception;
-			if (i == EXEXIT || i == EXEXEC)
+			if (i == EXEXIT)
 				goto raise;
 
 			status = (i == EXINT) ? SIGINT + 128 : 2;
diff --git a/src/exec.c b/src/exec.c
index 42299ea..b273420 100644
--- a/src/exec.c
+++ b/src/exec.c
@@ -141,7 +141,7 @@ shellexec(char **argv, const char *path, int idx)
 	exitstatus = exerrno;
 	TRACE(("shellexec failed for %s, errno %d, suppressint %d\n",
 		argv[0], e, suppressint ));
-	exerror(EXEXEC, "%s: %s", argv[0], errmsg(e, E_EXEC));
+	exerror(EXEXIT, "%s: %s", argv[0], errmsg(e, E_EXEC));
 	/* NOTREACHED */
 }
 
-- 
1.7.2.3


  reply	other threads:[~2010-10-07  3:38 UTC|newest]

Thread overview: 31+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2010-06-05 16:06 debian patches to exit with code 127 for nonexistent/directory scripts Jilles Tjoelker
2010-06-08 10:19 ` Herbert Xu
2010-06-08 10:36   ` Cristian Ionescu-Idbohrn
2010-06-11  8:39     ` Herbert Xu
2010-06-14  9:54 ` [PATCH] [INPUT] exit 127 if command_file is given but doesn't exist Gerrit Pape
2010-06-28  6:53   ` Herbert Xu
2010-10-06 10:04     ` [PATCH] [OPTIONS] Use exit status 127 when the script to run does not exist Jonathan Nieder
2010-10-06 10:08       ` [PATCH] [INPUT] Catch attempts to run a directory as a script Jonathan Nieder
2010-10-06 10:29         ` Herbert Xu
2010-10-06 10:55           ` Jonathan Nieder
2010-10-06 12:18             ` Eric Blake
2010-10-06 12:31               ` Herbert Xu
2010-10-07  1:02               ` [PATCH 0/3] Fix exit status for 'exec nonexistent' and 'exec .' Jonathan Nieder
2010-10-07  1:03                 ` [PATCH 1/3] [EXCEPTIONS] Stop documenting EXSHELLPROC Jonathan Nieder
2010-10-07  3:01                   ` Herbert Xu
2010-10-07  3:04                     ` Jonathan Nieder
2010-10-07  3:29                       ` Herbert Xu
2010-10-07  3:39                         ` [PATCH v2] " Jonathan Nieder
2010-11-28 12:47                           ` Herbert Xu
2010-10-07  1:04                 ` [PATCH 2/3] Revert "Eliminated global exerrno." Jonathan Nieder
2010-10-07  2:56                   ` Herbert Xu
2010-10-07  3:35                     ` Jonathan Nieder [this message]
2010-10-07  4:14                       ` Herbert Xu
2010-10-07  4:37                         ` Herbert Xu
2010-10-07 21:34                           ` Jonathan Nieder
2010-11-28 12:45                       ` Herbert Xu
2010-10-07  1:08                 ` [PATCH 3/3] [EXCEPTIONS] Eliminate global exerrno Jonathan Nieder
2010-10-07  3:00                   ` Herbert Xu
2010-11-28 12:06       ` [PATCH] [OPTIONS] Use exit status 127 when the script to run does not exist Herbert Xu
2010-11-28 12:24         ` Herbert Xu
2010-11-28 12:33           ` Herbert Xu

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20101007033518.GB2285@burratino \
    --to=jrnieder@gmail.com \
    --cc=dash@vger.kernel.org \
    --cc=eblake@redhat.com \
    --cc=herbert@gondor.apana.org.au \
    --cc=jari.aalto@cante.net \
    --cc=pape@smarden.org \
    --cc=sobkas@gmail.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox